#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed May 13 17:03:41 2020

@author: mario
"""

import networkx as nx
import re

# def lp_to_nx_graph(strInput):
#     nodePattern = re.compile(r'node\([0-9]+\.\.[0-9]+\)\.')
#     print(nodePattern.findall("node(0..195)."))
    
    
# lp_to_nx_graph("")


def cleanLP(lpSTR):
	lpSTR = lpSTR.replace(" ", "")
	lpSTR = lpSTR.replace("\t", "")
	newLPList = []
	for line in lpSTR.split("\n"):
		toAdd = line
		if "%" in line:
			toAdd = line[:line.index("%")]
		if toAdd != "":
			newLPList.append(toAdd)
	return newLPList

def lpStrToGraphNX(lpSTR):
	lpList = cleanLP(lpSTR)
	graph = nx.empty_graph(0)
	for part in lpList:
		if ".." in part and "node" in part:
			startrange = int(part[5:part.index("..")])
			endrange = int(part[part.index("..")+2:part.index(").")])
			graph.add_nodes_from(range(startrange, endrange))
		elif "." in part and ".." not in part:
			for i in part.split("."):
				if "node(" in i:
					graph.add_node(int(i[5:-1]))
				elif "edge(" in i:
					first = int(i[5:i.index(",")])
					second = int(i[i.index(",")+1:-1])
					graph.add_edge(first, second)
					if(first == 13 or first == 9):
						if(second == 13 or second == 9):
							print("Hello")
	return graph

def read(filenameRaw):
    fileIn = open(filenameRaw,'r')    
    graph = lpStrToGraphNX(fileIn.read())
    return graph